
@import 'helpers'
@import '../../app/spot/styles/sass/variables'

.op-wp-single-card
  display: flex
  user-select: none
  // Leave space for the shadow to be displayed
  width: calc(100% - 2px)
  border: 1px solid var(--color-border-muted)
  border-radius: 2px
  padding: 10px
  position: relative
  box-shadow: 1px 1px 3px 0px lightgrey
  background: var(--body-background)
  font-size: var(--body-font-size)

  &:hover
    .op-wp-single-card--inline-buttons
      opacity: 1
      z-index: 2
      background-image: linear-gradient(to left, rgba($spot-color-basic-white,1), rgba($spot-color-basic-white,0))

  &_new
    padding-right: 25px

  &_ghosted
    opacity: 0.5

  &_selected
    background-color: $spot-color-main-light
    .op-icon--wrapper
      background: $spot-color-main-light
    &:hover
      .op-wp-single-card--inline-buttons
        background-image: linear-gradient(to left, rgba($spot-color-main-light,1), rgba($spot-color-main-light,0))

  &_closed:not(&_selected)
    background-color: $spot-color-basic-gray-6
    .op-icon--wrapper
      background: $spot-color-basic-gray-6
    &:hover
      .op-wp-single-card--inline-buttons
        background-image: linear-gradient(to left, rgba($spot-color-basic-gray-6,1), rgba($spot-color-basic-gray-6,0))

  &_horizontal
    height: 100%

  &_vertical
    margin-top: 10px
    // Take care that the shadow of the last element is still visible
    &:last-of-type
      margin-bottom: 5px

  &_inline &--content
    grid-template-columns: max-content max-content auto auto 1fr
    grid-template-rows: auto max-content
    grid-template-areas: "status id project project project" "subject subject subject subject subject"

    &-assignee
      display: none
    &-subject-line
      display: flex
    &-subject
      flex-grow: 1
      @include text-shortener

  // Style shadow element while dragging
  wp-single-card:host.gu-transit &
    @include modifying--placeholder

  &--content

    &:not(.-new)
      display: grid
      grid-template-columns: max-content max-content auto auto 1fr
      grid-template-rows: auto 1fr max-content auto
      grid-row-gap: 5px
      grid-column-gap: 5px
      grid-template-areas: "status id project project project" "subject subject subject subject subject" "image image image image image" "avatar avatar avatar dates dates"
      overflow: hidden
      flex-grow: 1
      font-size: var(--body-font-size)
      line-height: 16px

    &-project-name
      grid-area: project
      font-style: italic
      color: var(--color-fg-muted)
      font-size: 12px
      @include text-shortener
    &-type
      grid-area: type
      margin-right: 4px
    &-subject-line
      grid-area: subject
      @include text-shortener(false)
    &-assignee
      margin-right: auto
      grid-area: avatar
      max-width: 140px
      color: var(--color-fg-muted)
      font-size: 12px
    &-id
      grid-area: id
      color: var(--color-fg-muted)
      font-size: 12px
    &-status-baseline
      grid-area: status
      margin-right: 5px
      max-width: 6.5rem
      display: flex
    &-status
      overflow: hidden
    &-baseline
      margin-left: $spot-spacing-0_5

      &-tooltip
        width: 6.5rem

    &-cover-image
      grid-area: image
      max-height: 350px

      @media screen and (max-width: $breakpoint-sm)
        max-height: 250px

    &-dates
      grid-area: dates
      place-self: center end
      white-space: nowrap
      color: var(--color-fg-muted)
      font-size: 12px

    &-inline-date
      font-size: 12px
      color: var(--color-fg-muted)
      margin: 0 8px
      white-space: nowrap

  &--highlighting
    width: 100%
    height: 2px
    position: absolute
    top: 0
    left: 0
    border-radius: 2px 2px 0 0

  &--card-actions
    display: flex
    position: absolute
    top: 9px
    right: 0

  &--card-action
    z-index: 2

    &_closed
      color: $spot-color-basic-gray-2

    .op-wp-single-card_selected &
      background-color: $spot-color-main-light

  &--inline-buttons
    opacity: 0
    padding-left: 30px
    padding-right: 4px
    white-space: nowrap

    // For selected cards the padding needs to be smaller
    // Otherwise the left-side color shading can overflow the card (e.g. in small cards in the team planner)
    .op-wp-single-card_selected &
      padding-left: 15px

    .op-icon--wrapper:not(&_selected)
      background: $spot-color-basic-white

    &.-show
      opacity: 1

    .op-wp-single-card_selected &
      background-color: $spot-color-main-light

  &--inline-cancel-button
    color: var(--warn)

  @media only screen and (max-width: $breakpoint-sm)
    &_shrink
      border: none
      box-shadow: none
      padding: 15px
